diff --git a/corefreq-cli.c b/corefreq-cli.c
index e76bfab0..ece69d54 100644
--- a/corefreq-cli.c
+++ b/corefreq-cli.c
@@ -2251,21 +2251,30 @@ void Top(SHM_STRUCT *Shm, char option)
 
     CUINT loadWidth = 0, MIN_HEIGHT = 0, MAX_ROWS = 0;
 
-    double minRatio = Shm->Proc.Boost[BOOST(MIN)],
-	   maxRatio = Shm->Proc.Boost[BOOST(1C)],
-	   medianRatio=(Shm->Proc.Boost[BOOST(ACT)] > 0) ?
-			Shm->Proc.Boost[BOOST(ACT)] : (minRatio + maxRatio) / 2,
-	   availRatio[BOOST(SIZE)] = {minRatio};
-
     HBCLK *hBClk;
 
     char *buffer = NULL;
 
     Coordinate *cTask;
 
-    unsigned int rdx;
-    for (rdx = BOOST(MAX); rdx < BOOST(SIZE); rdx++)
-	if (Shm->Proc.Boost[rdx] != 0) {
+    double minRatio = Shm->Proc.Boost[BOOST(MIN)],
+	maxRatio = Shm->Proc.Boost[BOOST(1C)],
+	medianRatio=(Shm->Proc.Boost[BOOST(ACT)] > 0) ?
+			Shm->Proc.Boost[BOOST(ACT)] : (minRatio + maxRatio) / 2,
+	availRatio[BOOST(SIZE)] = {minRatio};
+
+
+    void ComputeAvailableRatio()
+    {
+	unsigned int rdx;
+	// Update the ruller tab ratios.
+	minRatio = Shm->Proc.Boost[BOOST(MIN)];
+	maxRatio = Shm->Proc.Boost[BOOST(1C)];
+	medianRatio = (Shm->Proc.Boost[BOOST(ACT)] > 0) ?
+			Shm->Proc.Boost[BOOST(ACT)] : (minRatio + maxRatio) / 2;
+	ratioCount = 0;
+	for (rdx = BOOST(MAX); rdx < BOOST(SIZE); rdx++)
+	    if (Shm->Proc.Boost[rdx] != 0) {
 		int sort = Shm->Proc.Boost[rdx] - availRatio[ratioCount];
 		if (sort < 0) {
 			availRatio[ratioCount+1] = availRatio[ratioCount];
@@ -2273,8 +2282,9 @@ void Top(SHM_STRUCT *Shm, char option)
 		}
 		else if (sort > 0)
 			availRatio[++ratioCount] = Shm->Proc.Boost[rdx];
-	}
-    ratioCount++;
+	    }
+	ratioCount++;
+    }
 
 #define EraseTCell_Menu(win)						\
     ({									\
@@ -5720,10 +5730,10 @@ void Top(SHM_STRUCT *Shm, char option)
 	if (!BITVAL(Shm->Cpu[cpu].OffLine, HW))
 	{
 	struct FLIP_FLOP *Flop = &Shm->Cpu[cpu].FlipFlop[!Shm->Cpu[cpu].Toggle];
-
-
 		// Upper view area
-		CUINT	bar0 = (Flop->Relative.Ratio * loadWidth) / maxRatio,
+		CUINT	bar0 =((Flop->Relative.Ratio > maxRatio ?
+				maxRatio:Flop->Relative.Ratio)
+				* loadWidth) / maxRatio,
 			bar1 = loadWidth - bar0;
 		// Print the Per Core BCLK indicator (yellow)
 		LayerAt(layer, code, (LOAD_LEAD - 1), row) =		\
@@ -6971,21 +6981,24 @@ void Top(SHM_STRUCT *Shm, char option)
     {
     }
 
-    TrapScreenSize(SIGWINCH);
-    signal(SIGWINCH, TrapScreenSize);
+	/* Top starts here */
+	ComputeAvailableRatio();
+
+	TrapScreenSize(SIGWINCH);
+	signal(SIGWINCH, TrapScreenSize);
 
-    hBClk = calloc(Shm->Proc.CPU.Count, sizeof(HBCLK));
-    cTask = calloc(Shm->Proc.CPU.Count, sizeof(Coordinate));
+	hBClk = calloc(Shm->Proc.CPU.Count, sizeof(HBCLK));
+	cTask = calloc(Shm->Proc.CPU.Count, sizeof(Coordinate));
 
-    AllocAll(&buffer);
-    AllocDashboard();
+	AllocAll(&buffer);
+	AllocDashboard();
 
-    DISPOSAL_FUNC LayoutView[DISPOSAL_SIZE] = {
+	DISPOSAL_FUNC LayoutView[DISPOSAL_SIZE] = {
 		Layout_Header_DualView_Footer,
 		Layout_Dashboard,
 		Layout_NoHeader_SingleView_NoFooter
 	};
-    DISPOSAL_FUNC DynamicView[DISPOSAL_SIZE] = {
+	DISPOSAL_FUNC DynamicView[DISPOSAL_SIZE] = {
 		Dynamic_Header_DualView_Footer,
 		Draw_Dashboard,
 		Dynamic_NoHeader_SingleView_NoFooter
@@ -7013,9 +7026,13 @@ void Top(SHM_STRUCT *Shm, char option)
 	} else {
 		BITCLR(LOCKLESS, Shm->Proc.Sync, 0);
 	}
-	if (BITVAL(Shm->Proc.Sync, 63)) {
+	if (BITVAL(Shm->Proc.Sync, 62)) { // Compute required, clear the layout
+		ComputeAvailableRatio();
+		drawFlag.clear = 1;
+		BITCLR(LOCKLESS, Shm->Proc.Sync, 62);
+	}
+	if (BITVAL(Shm->Proc.Sync, 63)) { // Platform changed, redraw the layout
 		ClientFollowService(&localService, &Shm->Proc.Service, 0);
-		// Platform changed, redraw the layout.
 		drawFlag.layout = 1;
 		BITCLR(LOCKLESS, Shm->Proc.Sync, 63);
 	}
@@ -7036,8 +7053,8 @@ void Top(SHM_STRUCT *Shm, char option)
 
 		LayoutView[drawFlag.disposal](sLayer);
 	}
-	if (drawFlag.daemon) {
-
+	if (drawFlag.daemon)
+	{
 		DynamicView[drawFlag.disposal](dLayer);
 
 		// Increment the BCLK indicator (skip offline CPU)
diff --git a/corefreqd.c b/corefreqd.c
index 31c36a7b..47694cd7 100644
--- a/corefreqd.c
+++ b/corefreqd.c
@@ -2940,24 +2940,40 @@ void SysGate_Toggle(REF *Ref, unsigned int state)
 
 void Master_Ring_Handler(REF *Ref, unsigned int rid)
 {
+    void UpdateFeatures(void)
+    {
+	unsigned int cpu;
+
+	Package_Update(Ref->Shm, Ref->Proc);
+	for (cpu = 0; cpu < Ref->Shm->Proc.CPU.Count; cpu++)
+	    if (BITVAL(Ref->Core[cpu]->OffLine, OS) == 0)
+	    {
+		PerCore_Update(Ref->Shm, Ref->Proc, Ref->Core, cpu);
+	    }
+	Technology_Update(Ref->Shm, Ref->Proc);
+    }
+
     if (!RING_NULL(Ref->Shm->Ring[rid])) {
 	struct RING_CTRL ctrl = RING_READ(Ref->Shm->Ring[rid]);
-	if (ioctl(Ref->fd->Drv, ctrl.cmd, ctrl.arg) != -1) {
-		unsigned int cpu;
-
-		Package_Update(Ref->Shm, Ref->Proc);
-		for (cpu = 0; cpu < Ref->Shm->Proc.CPU.Count; cpu++)
-		    if (BITVAL(Ref->Core[cpu]->OffLine, OS) == 0)
-		    {
-			PerCore_Update(Ref->Shm, Ref->Proc, Ref->Core, cpu);
-		    }
-		Technology_Update(Ref->Shm, Ref->Proc);
-
-		if (Quiet & 0x100)
-		  printf("\tRING[%u](%x,%lx)\n",rid,ctrl.cmd,ctrl.arg);
-		// Notify
+	int rc = ioctl(Ref->fd->Drv, ctrl.cmd, ctrl.arg);
+	if (Quiet & 0x100)
+		printf("\tRING[%u](%x,%lx)>%d\n",rid,ctrl.cmd,ctrl.arg, rc);
+	switch (rc) {
+	case -EPERM:
+		break;
+	case 0: // Update SHM and notify a platform changed.
+		UpdateFeatures();
 		if (!BITVAL(Ref->Shm->Proc.Sync, 63))
 			BITSET(LOCKLESS, Ref->Shm->Proc.Sync, 63);
+		break;
+	case 2: // Update SHM, notify a compute is required,
+		UpdateFeatures();
+		if (!BITVAL(Ref->Shm->Proc.Sync, 62))
+			BITSET(LOCKLESS, Ref->Shm->Proc.Sync, 62);
+		// and platform has changed.
+		if (!BITVAL(Ref->Shm->Proc.Sync, 63))
+			BITSET(LOCKLESS, Ref->Shm->Proc.Sync, 63);
+		break;
 	}
     }
 }
diff --git a/corefreqk.c b/corefreqk.c
index 30c5b207..9c999af8 100644
--- a/corefreqk.c
+++ b/corefreqk.c
@@ -2850,10 +2850,6 @@ void Query_AMD_Zen(CORE *Core)					// Per SMT
 		case COREFREQ_TOGGLE_ON:
 			HwCfgRegister.Family_17h.CpbDis = !TurboBoost_Enable;
 			WRMSR(HwCfgRegister, MSR_K7_HWCR);
-			// Re-compute Turbo Boost ratios.
-			if (Core->Bind == Proc->Service.Core) {
-				Compute_AMD_Zen_Boost();
-			}
 			RDMSR(HwCfgRegister, MSR_K7_HWCR);
 		break;
 	}
@@ -6223,9 +6219,14 @@ static long CoreFreqK_ioctl(	struct file *filp,
 			case COREFREQ_TOGGLE_ON:
 					TurboBoost_Enable = arg;
 					Controller_Stop(1);
+					if (Proc->ArchID == AMD_Family_17h) {
+						Compute_AMD_Zen_Boost();
+						rc = 2;
+					} else {
+						rc = 0;
+					}
 					Controller_Start(1);
 					TurboBoost_Enable = -1;
-					rc = 0;
 				break;
 		}
 		break;
diff --git a/coretypes.h b/coretypes.h
index 35fcfddb..370cc595 100644
--- a/coretypes.h
+++ b/coretypes.h
@@ -4,7 +4,7 @@
  * Licenses: GPL2
  */
 
-#define COREFREQ_VERSION	"1.24.8"
+#define COREFREQ_VERSION	"1.24.9"
 
 enum {	GenuineIntel,		\
 	Core_Yonah,		\
